<?php
/*  Copyright 2004 Patrick R. Michaud (pmichaud@pobox.com)
    This file is part of PmWiki; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  See pmwiki.php for full details.

    This module sets the values of $PageStartFmt and $PageEndFmt,
    used by various modules to generate output pages.  The general
    mechanism for page output is that a function such as HandleBrowse
    or HandleEdit will output the value of $PageStartFmt, followed
    by the action-specific content, followed by $PageEndFmt.  The
    HTML comment <!--PageText--> in the template file denotes the
    location where $PageStart ends and $PageEnd begins.

    The template file may also contain HTML comments of the form
    <!--PageHeaderFmt-->, <!--PageFooterFmt-->, etc.  These
    have the side effect of putting the strings that follow into
    the variables $PageHeaderFmt, $PageFooterFmt, etc. and then
    placing references to those variables into $PageStartFmt or 
    $PageEndFmt.  This allows HandleBrowse and other functions to
    selectively disable headers and footers by setting the corresponding
    variable to the empty string.
*/

SDV($PageLogoUrl,"$PubDirUrl/skins/pmwiki/pmwiki-32.gif");
SDV($PageTemplateFmt,"pub/skins/pmwiki/pmwiki.tmpl");

if (!$PageTemplateFmt) return;

SDV($BasicLayoutVars,array('PageHeaderFmt','PageLeftFmt','PageTitleFmt',
  'PageText','PageRightFmt','PageFooterFmt'));

$sect = preg_split('/<!--(Page(?:Text|[A-Za-z]+Fmt))-->/',
  implode('',file(FmtPageName($PageTemplateFmt,$pagename))),0,
  PREG_SPLIT_DELIM_CAPTURE);
$PageStartFmt = array_merge('headers:',
  preg_split('/<!--((?:wiki|file|function):.*?)-->/',array_shift($sect),
    0,PREG_SPLIT_DELIM_CAPTURE));
$PageEndFmt = array();
$ps =& $PageStartFmt;
while (count($sect)>0) {
  $k = array_shift($sect);
  $v = preg_split('/<!--((?:wiki|file|function):.*?)-->/',
    array_shift($sect),0,PREG_SPLIT_DELIM_CAPTURE);
  $GLOBALS[$k] = (count($v)>1) ? $v : $v[0];
  if (in_array($k,$BasicLayoutVars)) {
    array_push($ps,"<!--$k-->");
    if ($k=='PageText') { $ps =& $PageEndFmt; }
    array_push($ps,&$GLOBALS[$k]);
  }
}
array_push($PageStartFmt,"\n<div id='wikitext'>\n");
array_unshift($PageEndFmt,'</div>');

?>
